#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_actor4xi.py">
#<abstract4xi abstract = "tests actors and casts sense-files to 3D coordinates"/>
#<verify4xi verification = "11" target = "actor4xi.py"/>
#<contextualize4xi context = "test_actor4xi.py"/>
#<use4xi usage = "
# BEFORE
#  > all2test4xi (produces the latest reason-xml files)
#  open own command window to run at the same time with two other scope-xml producers 
#
# RUN ONE INPUT FILE AT A TIME
#  1) select a file ScopeKb4Xi
#  2) call t test_actor4xi  > ..\txt\test_actor4xi.txt 
#"
#/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'print_trace4xi',
            'test_actor4xi',            
            'set_trace4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi  

import signal
import itertools
import weakref
import logging  
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "

from time4xi import time4xi

from actor4xi import coordinate_actors4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
#"
#/>

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test-actor4xi" usage = "
#   reads sense-xml files and creates scope-sense-xml-files
#   for example: reads sense-hello-world4xi.xml to create scope-sense-hello-world4xi.xml with 3D-coordinates  
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def test_actor4xi():
    # ---------------------------------------------------------------------------------------------
    # NEXT STEP: ZAP THE SCOPED FILE (run test_zap2actor4xi.py ...) !
    # ---------------------------------------------------------------------------------------------
    ScopeKb4Xi = {
       '..//..//xml//sense-after-fork4xi.xml': 'ack',                # REMEMBER: nack = scope it !
       '..//..//xml//sense-all-methods4xi.xml': 'ack',               #
       '..//..//xml//sense-current-process4xi.xml': 'ack',           #
       '..//..//xml//sense-dummy-process4xi.xml': 'ack',             #
       '..//..//xml//sense-finalize4xi.xml': 'ack',                  #
       '..//..//xml//sense-hello-pipe4xi.xml': 'ack' ,               #
       '..//..//xml//sense-hello-world4xi.xml': 'ack',               # third test 
       '..//..//xml//sense-math-two-4xi.xml': 'ack',                 #
       '..//..//xml//sense-math4xi.xml': 'ack',                      #
       '..//..//xml//sense-pickle4xi.xml': 'ack',                    #
       '..//..//xml//sense-pipe1-test4xi.xml': 'ack',                #
       '..//..//xml//sense-pool-one-4xi.xml': 'ack',                 #
       '..//..//xml//sense-processref4xi.xml': 'ack',                #
       '..//..//xml//sense-proxy-mp-test4xi.xml': 'ack',             #
       '..//..//xml//sense-public-methods-test4xi.xml': 'ack',       #
       '..//..//xml//sense-server4xi.xml': 'ack',                    #
       '..//..//xml//sense-shared-ctypes4xi.xml': 'ack',             #
       '..//..//xml//sense-sleep4xi.xml': 'ack',                     #
       '..//..//xml//sense-sync-manager-test4xi.xml': 'ack',         #
       '..//..//xml//sense-test-after_fork4xi.xml': 'ack',           #
       '..//..//xml//sense-test-arena4xi.xml': 'ack',                #
       '..//..//xml//sense-test-ball4xi.xml': 'ack',                 #
       '..//..//xml//sense-test-benchmark4xi.xml': 'ack',            #
       '..//..//xml//sense-test-constant-connection4xi.xml': 'ack',  #
       '..//..//xml//sense-test-constant-family4xi.xml': 'ack',      #
       '..//..//xml//sense-test-constant-forking4xi.xml': 'ack',     #
       '..//..//xml//sense-test-constant-heap4xi.xml': 'ack',        #
       '..//..//xml//sense-test-constant-logger4xi.xml': 'ack',      #
       '..//..//xml//sense-test-constant-managers4xi.xml': 'ack',    #
       '..//..//xml//sense-test-constant-pool4xi.xml': 'ack',        #
       '..//..//xml//sense-test-constant-process4xi.xml': 'ack',     #
       '..//..//xml//sense-test-constant-synchronize4xi.xml': 'ack', #
       '..//..//xml//sense-test-constant-system4xi.xml': 'ack',      #
       '..//..//xml//sense-test-constant-util4xi.xml': 'ack',        #
       '..//..//xml//sense-test-cpu-corecount4xi.xml': 'ack',        # 
       '..//..//xml//sense-test-format4xi.xml': 'ack',               #
       '..//..//xml//sense-test-kskeleton4xi.xml': 'ack',            #
       '..//..//xml//sense-test-locks4xi.xml': 'ack',                #
       '..//..//xml//sense-test-logger4xi.xml': 'ack',               #
       '..//..//xml//sense-test-manager4xi.xml': 'ack',              #
       '..//..//xml//sense-test-original-dir4xi.xml': 'ack',         #
       '..//..//xml//sense-test-server4xi.xml': 'ack',               #
       '..//..//xml//sense-test-shared-ctypes4xi.xml': 'ack',        #
       '..//..//xml//sense-test-skeleton-print4xi.xml': 'ack',       # second
       '..//..//xml//sense-test-sphere4xi.xml': 'ack',               #
       '..//..//xml//sense-test-state4xi.xml': 'ack',                #
       '..//..//xml//sense-test-uskeleton4xi.xml': 'ack',            # 
       '..//..//xml//sense-test-yskeleton4xi.xml': 'ack',            #
       '..//..//xml//sense-test-zskeleton4xi.xml': 'ack',            # first test
       '..//..//xml//sense-timeout4xi.xml': 'ack',                   #
       '..//..//xml//sense-token4xi.xml': 'ack',                     #
       '..//..//xml//sense-value-proxy4xi.xml': 'ack',               #
       '..//..//xml//sense-value-test4xi.xml': 'nack'}                # all done 7th of April 2014             

    # ---------------------------------------------------------------------------------------------
    # START                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(STEP 1/33) OF TEST_ACTOR4XI: STARTING ', time4xi())
    print('=' *33)
    
    len2kb= len(ScopeKb4Xi)

    print("(STEP 2/33) OF TEST_ACTOR4XI: MAX NUMBER OF XML FILES TO BE CHECKED - LEN2KB: ", len2kb)
 
    keys2kb = ScopeKb4Xi.keys()  
    
    
    # ---------------------------------------------------------------------------------------------
    # 
    # --------------------------------------------------------------------------------------------- 
    for key2kb in sorted(keys2kb):                                          
        print("(STEP 3/33) OF TEST_ACTOR4XI: CHECKING SCOPING STATUS OF FILE: ", key2kb)  
        
        if ScopeKb4Xi[key2kb] == 'nack':
            print("(STEP 4/33) OF TEST_ACTOR4XI: TRYING TO CREATE SCOPE-XML FROM INPUT FILE: ", key2kb)
            try:
                coordinate_actors4xi(key2kb)
     
                print("(STEP 5/33) OF TEST_ACTOR4XI: CREATED SCOPE-XML FROM INPUT FILE: ", key2kb)
            except:
                print("(STEP 6/33) OF TEST_ACTOR4XI *** FAILED TO CREATED SCOPE-XML FROM INPUT FILE: ", key2kb)   
        else:
            print("(STEP 7/33) OF TEST_ACTOR4XI: SKIPPED ALREADY SCOPED FILE: ", key2kb)
        
    # ---------------------------------------------------------------------------------------------
    # 
    # --------------------------------------------------------------------------------------------- 
    print("(STEP 7/33) OF TEST_ACTOR4XI: CREATED ALL SCOPED XML-FILES ", time4xi())  
                     
 
      
    # ---------------------------------------------------------------------------------------------
    # DONE                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(STEP 33/33) OF TEST_ACTOR4XI: DONE!', time4xi())
    print('=' *33)
        
   
         
       
#</function4xi>
     

                   
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function for test_actor4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def main():

    print('=' *33)
    print("SCOPING IT WITH YOURDRAGONXI ", time4xi())  
    print('=' *33)
        
    test_actor4xi()    
    
    print('=' *33)
    print("SCOPED IT WITH YOURDRAGONXI ", time4xi())    
    print('=' *33) 
                              
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
    
#</program4xi>
 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_actor4xi.txt
#   sense-test-actor4xi.xml
#
#   Note: sense and ace are not referred because only verbs are being tested and reason XMl created
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_actor4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
